## ghc 7.0.3

=== compiler/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

# If the user says 'make' or 'make stage=2' here, we behave as if they were
# in the ghc directory instead, so that the executable GHC gets built.
.PHONY: default_to_ghc all_ghc
default_to_ghc : all_ghc

dir = compiler
TOP = ..
SPEC_TARGETS = 1 2 3
include $(TOP)/mk/sub-makefile.mk

all_ghc :
	+$(TOPMAKE) all_ghc $(EXTRA_MAKE_OPTS)

FAST_MAKE_OPTS += compiler_stage1_NO_BUILD_DEPS=YES compiler_stage2_NO_BUILD_DEPS=YES compiler_stage3_NO_BUILD_DEPS=YES

.PHONY: 1 2 3

1:
	+$(TOPMAKE) stage=1 all_ghc_stage1 $(FAST_MAKE_OPTS) NO_STAGE1_DEPS=YES NO_STAGE2_DEPS=YES

2:
	+$(TOPMAKE) stage=2 all_ghc_stage2 $(FAST_MAKE_OPTS) NO_STAGE2_DEPS=YES

3:
	+$(TOPMAKE) stage=3 all_ghc_stage3 $(FAST_MAKE_OPTS) NO_STAGE3_DEPS=YES

.PHONY: extra-help
help : extra-help
extra-help :
	@echo "  make 1"
	@echo "  make 2"
	@echo "  make 3"
	@echo
	@echo "     Build the stage 1, 2 or 3 GHC respectively, omitting dependencies"
	@echo "     and initial phases for speed."

=== ghc/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = ghc
TOP = ..
SPEC_TARGETS = 1 2 3
include $(TOP)/mk/sub-makefile.mk

FAST_MAKE_OPTS += compiler_stage1_NO_BUILD_DEPS=YES \
                  compiler_stage2_NO_BUILD_DEPS=YES \
                  compiler_stage3_NO_BUILD_DEPS=YES \
                  ghc_stage1_NO_BUILD_DEPS=YES \
                  ghc_stage2_NO_BUILD_DEPS=YES \
                  ghc_stage3_NO_BUILD_DEPS=YES

.PHONY: 1 2 3

1:
	+$(TOPMAKE) stage=1 all_ghc_stage1 $(FAST_MAKE_OPTS) NO_STAGE1_DEPS=YES NO_STAGE2_DEPS=YES

2:
	+$(TOPMAKE) stage=2 all_ghc_stage2 $(FAST_MAKE_OPTS) NO_STAGE2_DEPS=YES

3:
	+$(TOPMAKE) stage=3 all_ghc_stage3 $(FAST_MAKE_OPTS) NO_STAGE3_DEPS=YES


# 'make re2' rebuilds stage2, removing the old executable first.  Useful for
# something like 'make re2 GhcDebugged=YES'.

.PHONY: re1 re2 re3
re1:
	$(RM) stage1/build/tmp/ghc-stage1
	$(MAKE) 1
re2:
	$(RM) stage2/build/tmp/ghc-stage2
	$(MAKE) 2
re3:
	$(RM) stage3/build/tmp/ghc-stage3
	$(MAKE) 3

.PHONY: extra-help
help : extra-help
extra-help :
	@echo "  make 1"
	@echo "  make 2"
	@echo "  make 3"
	@echo
	@echo "     Build the stage 1, 2 or 3 GHC respectively, omitting dependencies"
	@echo "     and initial phases for speed."

=== libraries/Cabal/Makefile ===

VERSION=1.10.1.0

#KIND=devel
KIND=rc
#KIND=latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide/
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/Cabal.markdown
	mkdir -p dist/doc/users-guide/
	$(PANDOC) $(PANDOC_OPTIONS) --from=markdown --to=html $< --output $@
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -c Cabal-$(VERSION) -zf $(DISTLOC)/Cabal-$(VERSION).tar.gz
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) www.haskell.org:/home/haskell/cabal/release/cabal-$(VERSION)
	ssh www.haskell.org 'cd /home/haskell/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/hpc/tests/ghc_ghci/Makefile ===
# This Makefile runs the tests using GHC's testsuite framework.  It
# assumes the package is part of a GHC build tree with the testsuite
# installed in ../../../testsuite.

TOP=../../../../testsuite
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

hpc_ghc_ghci:
	rm -f A.o A.hi
	'$(TEST_HC)' -fhpc -c A.hs
	echo b | '$(TEST_HC)' -ignore-dot-ghci -v0 --interactive B.hs

=== debian/changelog ===
ghc (7.0.3-1ubuntu1) oneiric; urgency=low

  * debian/control:
    + Build-Depend on ghc6 instead of ghc as the latter isn't available yet —
    it's what we're building now ;-) 
    + Remove ghc6* transitional packages. Could cause issues while ghc has to
    build-depend on ghc6. Once we know ghc has built we can revert all of the
    changes in this upload.

 -- Iain Lane <laney@ubuntu.com>  Fri, 06 May 2011 19:47:31 +0100

ghc (7.0.3-1) unstable; urgency=low

  * Remove Build-Conflict on dash, as a fixed package has been uploaded. 
  * Do not provide utf8-string or xhtml, as they are only built internally. 
  * Remove Build-Depend alternative ghc6, and also remove Provides: ghc6, as
    this is a lie and I see no techical reason for it.
  * New upstream release
  * Avoid "hPutChar: resource vanished" message and simplify postinst script
    (Closes: #619403)
  * Remove package cache in prerm, even on upgrade. This is the right thing to
    do if upgrading to a new upstream release, and does not hurt in the other
    cases.

 -- Joachim Breitner <nomeata@debian.org>  Sat, 09 Apr 2011 21:43:15 +0530

ghc (7.0.2-7) unstable; urgency=low

  * Upload to unstable

 -- Joachim Breitner <nomeata@debian.org>  Sat, 26 Mar 2011 21:45:53 +0530

ghc (7.0.2-6) experimental; urgency=low

  * Set a dummy HOME variable upon build. Some build daemons do not set HOME,
    but ghc-cabal expects it to be available.

 -- Joachim Breitner <nomeata@debian.org>  Fri, 25 Mar 2011 12:47:29 +0530

ghc (7.0.2-5) experimental; urgency=low

  * Build-Conflict with broken version of dash (See #618023)
  * Link ghc-doc to haddock via virtual package "haddock-interface-<n>"
  * Remove redundand Build-dependency on autoconf 

 -- Joachim Breitner <nomeata@debian.org>  Wed, 23 Mar 2011 12:03:56 +0530

ghc (7.0.2-4) experimental; urgency=low

  * ghc6-preinst: Remove package.cache file of any ghc6 installation to avoid
    dpkg warning at upgrade time.
  * Build-conflict with ccache. pbuilder installs ccache by default, which
    causes ghc to pick up a wrong path for "gcc". 
  * Pass -lpthread everywhere. This can possibly be dropped later. 

 -- Joachim Breitner <nomeata@debian.org>  Fri, 11 Mar 2011 14:00:11 +0530

ghc (7.0.2-3) experimental; urgency=low

  [ Iain Lane ]
  * debian/rules: Build with -mminimal-toc on ppc64 — thanks to Colin
    Watson for investigation and patch.

  [ Joachim Breitner ]
  * Disable the use of epoll_create1 and use epoll_create, as the former is
    not available on Linux kernels earlier than 2.6.27.
    http://hackage.haskell.org/trac/ghc/ticket/5005

 -- Joachim Breitner <nomeata@debian.org>  Wed, 09 Mar 2011 21:44:50 +0530

ghc (7.0.2-2) experimental; urgency=low

  [ Joachim Breitner ]
  * Remove procps dependency (watcher.hs has been removed since a while)
  * Build-depend and depend on libgmp-dev instead of libgmp3-dev.

  [ Erik de Castro Lopo ]
  * Add patch to fix powerpc compile error (powerpc-compile-616635)
    (Closes: #616635)

  [ Joachim Breitner ]
  * fix FTBFUS by removing left-over binaries

 -- Joachim Breitner <nomeata@debian.org>  Tue, 08 Mar 2011 13:01:18 +0530

ghc (7.0.2-1) experimental; urgency=low

  * (Closes: 554174) Segfaults at startup not observable any more
  * Tweak debian/copyright
  * New upstream release (Should help to close 616494)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 05 Mar 2011 22:04:21 +0530

ghc (7.0.1-1) experimental; urgency=low

  [ Joachim Breitner ]
  * New upstream release, some patches included.
  * Package adopted by the Debian Haskell Group. Thanks to kaol for his
    work!
  * Rename source and binary packages to ghc, include transitional dummy
    package
  * Standards-Version 3.9.1 (no changes necessary)

  [ Erik de Castro Lopo ]
  * Re-enable building of ghci on powerpc. (Closes: 557185)

 -- Joachim Breitner <nomeata@debian.org>  Mon, 17 Jan 2011 12:49:24 +0530

ghc6 (6.12.3-1) experimental; urgency=low

  * New upstream release
    * ghci :m now works with module names containing ' (Closes: #580568)
  * Put haddock and the shared libraries into their own packages.
    (Closes: #571537)
  * Only insert packages in gen_contents_index which are both registered
    and for which the html directory exists.
  * Use ghc-pkg --global in ghc6's trigger to avoid accessing HOME.
    (Closes: #578679)
  * Fix directories in haddock manpage.  (Closes: #578321)
  * Apply some patches from Gentoo (thanks, Sergei Trofimovich) hopefully
    fixing ia64 build.
  * Downgrade ghc6's dependency on perl to Suggests and have ghc6-doc
    depend on perl.  (Closes: #553332)
  * Standards-Version 3.9.0 (no changes necessary)
  * ghc6 package now provides ghc6-ghci on architectures where it's
    supported (i386 and amd64 only currently).

 -- Kari Pahula <kaol@debian.org>  Tue, 20 Jul 2010 19:19:20 +0300

ghc6 (6.12.1-13) unstable; urgency=low

  * Remove debian/watcher.sh.  (Closes: #571824)
  * Don't ship /var/lib/ghc-6.12.1/package.conf.d/package.cache with ghc6.
    (Closes: #574417)
  * Patch compiler/rename/RnSource.lhs to make hlist happy.
  * Remove some more generated .hc files in debian/rules clean.
  * Don't ship broken symlink /usr/lib/ghc-6.12.1/package.conf

 -- Kari Pahula <kaol@debian.org>  Sat, 17 Apr 2010 10:35:25 +0300

ghc6 (6.12.1-12) unstable; urgency=low

  * Fix the kfreebsd-* patch.
  * Don't die in ghc6's trigger if ghc-pkg check fails.  (Closes: #570921)
  * Recognise DEB_BUILD_OPTIONS=parallel.

 -- Kari Pahula <kaol@debian.org>  Mon, 22 Feb 2010 15:08:48 +0200

ghc6 (6.12.1-11) unstable; urgency=low

  * Add "unset LC_ALL\nexport LC_CTYPE=en_US" to bin/ghc wrapper on ia64.
  * Actually append GhcWithInterpreter=YES to mk/build.mk on kfreebsd-*,
    don't just echo it to stdout.

 -- Kari Pahula <kaol@debian.org>  Mon, 22 Feb 2010 03:24:02 +0200

ghc6 (6.12.1-10) unstable; urgency=low

  * Use dh_haskell_depends from haskell-devscripts to create provides
    including the packages ABI.


=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Standards-Version: 3.9.1
Build-Depends:
  debhelper (>= 7),
  libgmp-dev,
  devscripts,
  ghc6,
  grep-dctrl,
  autotools-dev,
  gcc (>= 4:4.2),
  libffi-dev,
  pkg-config,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  binutils (>= 2.19.51.20090508) [arm armel],
  libncurses5-dev
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/

Package: ghc
Architecture: any
Depends: gcc (>= 4:4.2), libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: ghc6 (<< 7)
Conflicts: ghc6 (<< 7)
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7)
Conflicts: ghc6-doc (<< 7)
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

Package: ghc-dynamic
Architecture: i386 amd64
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Dynamic libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package has dynamically linkable, shared versions of the
 libraries included with GHC.  Currently, they are available only on
 i386 and amd64 architectures.

Package: ghc-haddock
Architecture: any
Provides: haddock, ${haddock:Provides}
Conflicts: haddock
Depends: ghc, ${misc:Depends}, ${shlibs:Depends}
Homepage: http://www.haskell.org/haddock/
Description: Documentation tool for annotated Haskell source code
 Haddock is a tool for automatically generating documentation from
 annotated Haskell source code.  It is primary intended for documenting
 libraries, but it should be useful for any kind of Haskell code.
 .
 Haddock lets you write documentation annotations next to the
 definitions of functions and types in the source code, in a syntax
 that is easy on the eye when writing the source code (no heavyweight
 mark-up).  The documentation generated by Haddock is fully hyperlinked:
 click on a type name in a type signature to go straight to the
 definition, and documentation, for that type.
 .
 Haddock can generate documentation in multiple formats; currently HTML
 is implemented, and there is partial support for generating DocBook.
 .
 This package contains Haddock version 2.8.0.

#Package: ghc6
#Architecture: all
#Depends: ghc, ${misc:Depends}
#Description: transitional dummy package
# This package ensures a smooth transition from the package name ghc6 to the
# package name ghc, and can safely be removed.

#Package: ghc6-doc
#Architecture: all
#Depends: ghc-doc, ${misc:Depends}
#Section: doc
#Description: transitional dummy package
# This package ensures a smooth transition from the package name ghc6-doc to the
# package name ghc-doc, and can safely be removed.

#Package: ghc6-prof
#Architecture: all
#Depends: ghc-prof, ${misc:Depends}
#Description: transitional dummy package
# This package ensures a smooth transition from the package name ghc6-prof to the
# package name ghc-prof, and can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell awk -F\' "/^PACKAGE_VERSION='[0-9.]+'\$$/ { print \$$2 }" configure)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir

	touch configure

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc))
	echo "GhcUnregisterised=NO" >> mk/build.mk
else
	echo "GhcUnregisterised=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
	echo "GhcWithInterpreter=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel alpha ia64))
	echo "UseLibFFIForAdjustors=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
# proper fix for #360177
ifeq (ppc64,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	mkdir -p debian/haddock-build
	cp -r utils/haddock debian/haddock-build
	sed -i s/@PROJECTVERSION@/$(ProjectVersion)/ debian/haddock-build/haddock/src/Main.hs
	cd debian/haddock-build/haddock; \
		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
			--package-db=../../../inplace/lib/package.conf.d/ \
			--htmldir=/usr/share/doc/ghc-haddock/html/ \
		; \
		./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs /var/lib/ghc-$(ProjectVersion)/package.conf.d

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc-$(ProjectVersion)
	mv debian/tmp/usr/lib/ghc-$(ProjectVersion)/package.conf.d \
	   debian/tmp/var/lib/ghc-$(ProjectVersion)/
	rm debian/tmp/var/lib/ghc-$(ProjectVersion)/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64))
	echo 'ghci=ghc-ghci' >> debian/ghc.substvars
endif
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-$(ProjectVersion)/haddock/,' debian/tmp/var/lib/ghc-$(ProjectVersion)/package.conf.d/*.conf

	# Remove haddock as built within the ghc tree
	rm -f debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin/haddock \
	      debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin/haddock-$(ProjectVersion) \
	      debian/tmp/usr/lib/ghc-$(ProjectVersion)/lib/haddock
	rm -rf debian/tmp/usr/lib/ghc-$(ProjectVersion)/html

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc-$(ProjectVersion) ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	cd debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc-$(ProjectVersion)/bin/$$f \
	             ../../../bin/$${f}; \
	    done
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp

	ProjectVersion=$(ProjectVersion) $(MAKE) -f debian/scripts.mk all

	# Add haddock substvars
	echo "haddock:Depends=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc-doc
